/* --------------------------------------------------------------------------------------------
 *  EL-POINT subset version for KARIHITO
 *  music creative driver for Win32 Netscape Plug-in
 *  (C) 1999,2000 Ƃ悵
 * --------------------------------------------------------------------------------------------
 *  [GraphicTextGDI.h]
 *   eLXg\邽߂̃NXBeLXg\KvAGDIpłNXp
 *  eLXg\sBDrawText/DrawString͑OSetDCResetDCň͂ޕKvB
 * -------------------------------------------------------------------------------------------- */

#if !defined(__GraphicTextGDI_h__)
#define	__GraphicTextGDI_h__

#if !defined(__Common_h__)
#	include "Common.h"
#endif	// !defined(__Common_h__)

class GraphicTextGDI{
private:
	HFONT hFont;
	HDC hDc;
	int align_width;
	int align_height;
	unsigned long color;
	unsigned long back_color;
	bool transparent;
public:
	GraphicTextGDI(void);
	~GraphicTextGDI(void);
	bool SetFont(int size);
	void SetAlign(int width, int height);
	void SetColor(int r, int g, int b);
	void SetBackColor(int r, int g, int b);
	void Transparent(bool on);

	bool DrawText(int x, int y, int code);
	bool DrawString(int x, int y, char *string);

	void SetDC(HDC hDc);
	void ResetDC(void);
};

#if !defined(__GraphicTextGDI__)
#	define	__GraphicTextGDI__
#endif	// !defined(__GraphicTextGDI__)

#endif	// !defined(__GraphicTextGDI_h__)
