/* --------------------------------------------------------------------------------------------
 *  music creative driver for Win32 Netscape Plug-in
 *  (C) 1999,2000 Ƃ悵
 * --------------------------------------------------------------------------------------------
 *  [HashedWindowProcDivider.h]
 *   EBhEƃNX̃CX^Xт邱Ƃ\ɂAC++ł̃EBhE
 *  Rɍs悤ɂBEBhEƃCX^Xт邽߂ɃnbVe[u
 *  pĂB
 * -------------------------------------------------------------------------------------------- */
#if !defined(__HashedWindowProcDivider_h__)
#	define	__HashedWindowProcDivider_h__

#	if !defined(__Common_h__)
#		include "Common.h"
#	endif	// !defined(__Common_h__)

abstract class HashedWindowProcDivider{
typedef struct _ENTRY{
	HWND hWnd;
	HashedWindowProcDivider *instance;
	struct _ENTRY *next;
	struct _ENTRY *before;
} ENTRY, *LPENTRY;
private:
	static LPENTRY table[256];
	static bool initialize;
public:
	static bool WndEntryAdd(HWND hWnd, HashedWindowProcDivider *instance);
	static bool WndEntryDel(HWND hWnd);
	static LRESULT CALLBACK WindowProcWrap(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam);
	virtual LRESULT WindowProc(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam) = 0;
private:
	static void Initialize(void);
	static inline LPENTRY Search(HWND hWnd);
};

#	if !defined(__HashedWindowProcDivider__)
#		define	__HashedWindowProcDivider__
#	endif	// !defined(__HashedWindowProcDivider__)

#endif	// !defined(__HashedWindowProcDivider__)
